
#property indicator_separate_window
#property indicator_buffers    4
#property indicator_color1     Red
#property indicator_width1     2
#property indicator_color2     SteelBlue
#property indicator_width2     2
#property indicator_color3     DarkSlateGray
#property indicator_width3     2
#property indicator_color4     Magenta 
#property indicator_style4     STYLE_DASH
#property indicator_levelcolor DarkSlateGray

//
//
//
//
//

extern int    FastMa                 = 12;
extern string FastMAModes            = "SMA0,EMA1,SmmMA2,LWMA3";
extern int    FastMaMode             = MODE_EMA;
extern string FastPrices             = "0C,1O,2H,3L,4M,5T,6W";
extern int    FastMaPrice            = PRICE_CLOSE;
extern int    SlowMa                 = 26;
extern string SlowMAModes            = "SMA0,EMA1,SmmMA2,LWMA3";
extern int    SlowMaMode             = MODE_EMA;
extern string SlowPrices             = "0C,1O,2H,3L,4M,5T,6W";
extern int    SlowMaPrice            = PRICE_CLOSE;
extern int    SignalMa               = 9;
extern string SignMAModes            = "SMA0,EMA1,SmmMA2,LWMA3";
extern int    SignalMaMode           = MODE_SMA;

extern string _                      = "Alerts Settings";
extern bool   alertsOn               = true;
extern bool   alertsOnZeroCross      = false;
extern bool   alertsOnSignalCross    = true;
extern bool   alertsOnCurrent        = false;
extern bool   alertsMessage          = true;
extern bool   alertsSound            = true;
extern bool   alertsNotify           = false;
extern bool   alertsEmail            = false;
extern string soundFile              = "alert2.wav"; 

extern bool   arrowsVisible          = true;
extern string arrowsIdentifier       = "macd Arrows1";
extern double arrowsDisplacement     = 1.0;

extern bool   arrowsOnZeroCross      = false;
extern color  arrowsUpZeroCrossColor = DeepSkyBlue;
extern color  arrowsDnZeroCrossColor = Red;
extern int    arrowsUpZeroCrossCode  = 233;
extern int    arrowsDnZeroCrossCode  = 234;
extern int    arrowsUpZeroCrossSize  = 1;
extern int    arrowsDnZeroCrossSize  = 1;

extern bool   arrowsOnSignalCross    = true;
extern color  arrowsUpSignalColor    = LimeGreen;
extern color  arrowsDnSignalColor    = Red;
extern int    arrowsUpSignalCode     = 119;
extern int    arrowsDnSignalCode     = 119;
extern int    arrowsUpSignalSize     = 2;
extern int    arrowsDnSignalSize     = 2;

//
//
//
//
//

double macdDn[]; 
double macdUp[]; 
double sign[];
double macd[];
double trend1[];
double trend2[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{

   IndicatorBuffers(6);
   SetIndexBuffer(0,macdDn); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,macdUp); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,macd);
   SetIndexBuffer(3,sign);
   SetIndexBuffer(4,trend1);
   SetIndexBuffer(5,trend2);
      
   FastMa   = MathMax(FastMa,1);
   SlowMa   = MathMax(SlowMa,1);
   SignalMa = MathMax(SignalMa,1);
   IndicatorShortName("macd("+FastMa+","+SlowMa+","+SignalMa+")");
return(0);
}

int deinit() 
{ 
   if (arrowsVisible) deleteArrows(); 
   
return(0); 
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int i,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //
  
   for (i=limit; i>=0; i--) macd[i] = iMA(NULL,0,FastMa,0,FastMaMode,FastMaPrice,i) - iMA(NULL,0,SlowMa,0,SlowMaMode,SlowMaPrice,i);
   for (i=limit; i>=0; i--) sign[i] = iMAOnArray(macd,Bars,SignalMa,0,SignalMaMode,i);
   for (i=limit; i>=0; i--) 
   {      
       macdDn[i] = EMPTY_VALUE;
       macdUp[i] = EMPTY_VALUE;
       trend1[i] = trend1[i+1];
       trend2[i] = trend2[i+1];
          if (macd[i] > 0)       trend1[i]  =  1;
          if (macd[i] < 0)       trend1[i]  = -1;
          if (macd[i] > sign[i]) trend2[i]  =  1;
          if (macd[i] < sign[i]) trend2[i]  = -1;
          if (trend1[i] == 1) macdUp[i] = macd[i];
          if (trend1[i] ==-1) macdDn[i] = macd[i];
          manageArrow(i);
               
    }
    manageAlerts();
return(0);
} 
      
//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; 

      //
      //
      //
      //
      //
            
      static datetime time1 = 0;
      static string   mess1 = "";
      if (alertsOnZeroCross && trend1[whichBar] != trend1[whichBar+1])
      {
         if (trend1[whichBar] ==  1) doAlert(time1,mess1,whichBar,"Crossed zero line up");
         if (trend1[whichBar] == -1) doAlert(time1,mess1,whichBar,"Crossed zero line down");
      }
      
      static datetime time2 = 0;
      static string   mess2 = "";
      if (alertsOnSignalCross && trend2[whichBar] != trend2[whichBar+1])
      {
         if (trend2[whichBar] ==  1) doAlert(time2,mess2,whichBar,"Signal cross up");
         if (trend2[whichBar] == -1) doAlert(time2,mess2,whichBar,"Signal cross down");
      }
      
   }
}

//
//
//
//
//

void doAlert(datetime& previousTime, string& previousAlert, int forBar, string doWhat)
{
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  Symbol()+" at "+TimeToStr(TimeLocal(),TIME_SECONDS)+" Macd "+doWhat;
          if (alertsMessage) Alert(message);
          if (alertsNotify)  SendNotification(StringConcatenate(Symbol(), Period() ," Macd " +" "+message));
          if (alertsEmail)   SendMail(StringConcatenate(Symbol()," Macd "),message);
          if (alertsSound)   PlaySound(soundFile);
   }
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void manageArrow(int i)
{
   if (arrowsVisible)
   {
      deleteArrow(Time[i]);
      if (arrowsOnZeroCross && trend1[i] != trend1[i+1])
      {
         if (trend1[i] == 1) drawArrow(i,arrowsUpZeroCrossColor,arrowsUpZeroCrossCode,arrowsUpZeroCrossSize,false);
         if (trend1[i] ==-1) drawArrow(i,arrowsDnZeroCrossColor,arrowsDnZeroCrossCode,arrowsDnZeroCrossSize,true);
      }
      
      if (arrowsOnSignalCross && trend2[i]!= trend2[i+1])
      {
         if (trend2[i] == 1) drawArrow(i,arrowsUpSignalColor,arrowsUpSignalCode,arrowsUpSignalSize,false);
         if (trend2[i] ==-1) drawArrow(i,arrowsDnSignalColor,arrowsDnSignalCode,arrowsDnSignalSize,true);
      }
      
   }
}               

//
//
//
//
//

void drawArrow(int i,color theColor,int theCode,int theSize, bool up)
{
   string name = arrowsIdentifier+":"+Time[i];
   double gap  = iATR(NULL,0,20,i);   
   
      //
      //
      //
      //
      //
      
      ObjectCreate(name,OBJ_ARROW,0,Time[i],0);
         ObjectSet(name,OBJPROP_ARROWCODE,theCode );
         ObjectSet(name,OBJPROP_COLOR,    theColor);
         ObjectSet(name,OBJPROP_WIDTH,    theSize );      
         
         if (up)
               ObjectSet(name,OBJPROP_PRICE1,High[i] + arrowsDisplacement * gap);
         else  ObjectSet(name,OBJPROP_PRICE1, Low[i] - arrowsDisplacement * gap);
}

//
//
//
//
//

void deleteArrows()
{
   string lookFor       = arrowsIdentifier+":";
   int    lookForLength = StringLen(lookFor);
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string objectName = ObjectName(i);
         if (StringSubstr(objectName,0,lookForLength) == lookFor) ObjectDelete(objectName);
   }
}

//
//
//
//
//

void deleteArrow(datetime time)
{
   string lookFor = arrowsIdentifier+":"+time; ObjectDelete(lookFor);
}

